<?php
namespace FiloBlu\Popup\Model\Config\Source;

class Popup implements \Magento\Framework\Option\ArrayInterface
{

    protected $_collectionFactory;
    protected $_escaper;
    
    public function __construct(
        \FiloBlu\Popup\Model\ResourceModel\Popup\CollectionFactory $collectionFactory, 
        \Magento\Framework\Escaper $escaper
    ) {
        $this->_collectionFactory = $collectionFactory;
        $this->_escaper = $escaper;
    }
    
    /**
     * @return array
     */
    public function toOptionArray($default = false)
    {
        $collection = $this->_collectionFactory->create();
        $array = [];
        
        if ($default) {
            $array[] = [
                'label' => __('All Popup'),
                'value' => 0
            ];
        }
        
        foreach ($collection as $popup) {
            $array[] = [
                'label' => $this->_escaper->escapeQuote($popup->getId() . ' - ' . $popup->getTitle(), true),
                'value' => $popup->getId()
            ];
        }
        
        return $array;
    }
    
}
